﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using SilverNBTLibrary;
using SilverNBTLibrary.Structure;

namespace ScaleUpper
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            using (StreamWriter sw = new StreamWriter("Settings.dat", false, Encoding.UTF8))
            {
                sw.WriteLine((int)numericUpDown1.Value);
                sw.WriteLine((int)numericUpDown2.Value);
                sw.WriteLine((int)numericUpDown3.Value);

            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            if(File.Exists("Settings.dat"))
            {
                using (StreamReader sr = new StreamReader("Settings.dat", Encoding.UTF8))
                {
                    numericUpDown1.Value = int.Parse(sr.ReadLine());
                    numericUpDown2.Value = int.Parse(sr.ReadLine());
                    numericUpDown3.Value = int.Parse(sr.ReadLine());
                }
            }

            if(!Directory.Exists("OutPut"))
            {
                Directory.CreateDirectory("OutPut");
            }
        }

        private void panel1_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {

                // ドラッグ中のファイルやディレクトリの取得
                string[] drags = (string[])e.Data.GetData(DataFormats.FileDrop);

                foreach (string d in drags)
                {
                    if (!System.IO.File.Exists(d))
                    {
                        // ファイル以外であればイベント・ハンドラを抜ける
                        return;
                    }
                }
                e.Effect = DragDropEffects.Copy;
            }
        }

        private void panel1_DragDrop(object sender, DragEventArgs e)
        {
            string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);
            int xscale = (int)numericUpDown1.Value;
            int yscale = (int)numericUpDown2.Value;
            int zscale = (int)numericUpDown3.Value;

            for(int i = 0; i < files.Length; i++)
            {
                string file = files[i];
                if(file.EndsWith(".schematic")||file.EndsWith(".nbt"))
                {
                    using(FileStream stram = File.OpenRead(file))
                    {
                        NBTTagCompound comp = NBTFile.LoadFromStream(stram);
                        StructualBase s;
                        if (file.EndsWith(".schematic"))
                        {
                            s = Schematic.LoadFromNBT(comp);
                        }
                        else
                        {
                            s = StructureTemplate.LoadFromNBT(comp);
                        }

                        if (s == null)
                            continue;

                        StructualBase sm;
                        if(radioButton1.Checked)
                        {
                            sm = new Schematic(s.Width * xscale, s.Height * yscale, s.Length * zscale);
                        }
                        else
                        {
                            sm = new StructureTemplate(s.Width * xscale, s.Height * yscale, s.Length * zscale);
                        }

                        for(int z = 0; z < s.Length; z++)
                            for(int y = 0; y < s.Height; y++)
                                for (int x = 0; x < s.Width; x++)
                                {
                                    for (int l = 0; l < xscale; l++)
                                        for (int m = 0; m < yscale; m++)
                                            for (int n = 0; n < zscale; n++)
                                            {
                                                int id = s.GetBlockId(x, y, z);
                                                int meta = s.GetBlockMetadata(x, y, z);
                                                sm.SetBlock(x * xscale + l, y * yscale + m, z * zscale + n, s.GetBlockId(x, y, z), s.GetBlockMetadata(x, y, z));
                                                int id2 = sm.GetBlockId(x * xscale + l, y * yscale + m, z * zscale + n);
                                                //Console.WriteLine("{0} / {1}", id, id2);
                                            }
                                }

                        string filePath = GetUniqueFileName(file, radioButton1.Checked ? ".schematic" : ".nbt");
                        string qqs = Path.GetFullPath(filePath);
                        NBTFile.SaveToFile(qqs, sm.SaveToNBT());
                    }
                    
                }
            }

        }

        public string GetUniqueFileName(string str,string extension)
        {
            //string extension = Path.GetExtension(str);
            string _n = "OutPut\\" + Path.GetFileName(str);
            if(!File.Exists(_n))
                return _n;
            for(int i = 1; ;i++)
            {
                string _m = "OutPut\\" + Path.GetFileNameWithoutExtension(str) + i + "" + extension;
                if (!File.Exists(_m))
                    return _n;
            }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {

        }
    }
}
